<?php
/**
 * $Id: notifyproduct.php 1.0.0 2013-04-17 11:21:25 Luiz Weber $
 * @package	    Virtuemart Notify Product
 * @subpackage	Virtuemart Notify Product
 * @version     1.0.0
 * @copyright	Copyright © 2013 - Webgenium System All rights reserved.
 * @license		GNU General Public License v2.0
 * @author		Luiz Weber
 * @author mail	suporte@webgenium.com.br
 * @website		http://webgenium.com.br
 *
 * The events triggered in Joomla!
 * -------------------------------
 * onAfterInitialise()
 * onAfterRoute()
 * onAfterDispatch()
 * onAfterRender()
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgSystemNotifyproduct extends JPlugin {
	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @access	      protected
	 * @param	object	$subject The object to observe
	 */
    function plgSystemNotifyproduct( &$subject, $config )
    {
       parent::__construct( $subject, $config );

       // Do some extra initialisation in this constructor if required
    }

    function onAfterInitialise() {
      // Your custom code here
    }

	function onAfterDispatch() {

    }

    function onAfterRender() {

    }

    function onAfterRoute (){

		$app =& JFactory::getApplication();
		if($app->getName() != 'site') {
			return true;
		}

		$lang =& JFactory::getLanguage();
		$extension = 'plg_system_notifyproduct';
		$base_dir = JPATH_ADMINISTRATOR;
		$language_tag = null;
		$reload = true;
		$lang->load($extension, $base_dir, $language_tag, $reload);

		$virtuemart_product_id 	= JRequest::getVar('virtuemart_product_id');
		$option 				= JRequest::getVar('option');
		$virtuemart_user_id 	= JRequest::getVar('virtuemart_user_id');
		$task 					= JRequest::getVar('task');

		//if ($virtuemart_product_id and $option == 'com_virtuemart' and $task == 'notifycustomer' ) {
		if ($task == 'notifycustomer' ) {

			$virtuemart_product_id = (int)$virtuemart_product_id;
			if (!class_exists ('shopFunctionsF')) {
				require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
			}

			$db = JFactory::getDbo ();
			$q = "SELECT l.product_name,product_in_stock, p.product_sku FROM `#__virtuemart_products_" . VMLANG . "` l
					JOIN `#__virtuemart_products` p ON p.virtuemart_product_id=l.virtuemart_product_id
				   WHERE p.virtuemart_product_id = " . $virtuemart_product_id;
			$db->setQuery ($q);
			$item = $db->loadObject ();

			$notify_email = JRequest::getVar('notify_email');
			$url = JURI::root () . 'index.php?option=com_virtuemart&view=productdetails&virtuemart_product_id=' . $virtuemart_product_id;
			$link_product = '<a href="'. $url.'">#'.$item->product_sku.' - '. $item->product_name.'</a>';

			$subject = JText::sprintf('PLG_NOTIFICATION_SUBJECT_MAIL',$item->product_name);
			$mailbody = JText::sprintf('PLG_NOTIFICATION_BODY_MAIL',$notify_email,$link_product);

			$virtuemart_vendor_id = 1;
			$vendorModel = VmModel::getModel ('vendor');
			$vendor = $vendorModel->getVendor ($virtuemart_vendor_id);
			$vendorModel->addImages ($vendor);
			$vendorEmail = $vendorModel->getVendorEmail ($virtuemart_vendor_id);

			$alternative_email = $this->params->get('alternative_email','');
			if ($alternative_email != '') {
				$vendorEmail = $alternative_email;
			}

			$mailer = JFactory::getMailer();
			$mailer->addReplyTo($notify_email);
			$mailer->addRecipient($vendorEmail);
			$mailer->setSubject($subject);
			$mailer->setBody($mailbody);
			$mailer->isHTML();
			if ($mailer->send()) {
				JFactory::getApplication()->enqueueMessage( JText::_('PLG_NOTIFICATION_MAIL_SENT') );				
			}
		}
    }
}

?>